interface StackConnectionConfig {
    apiKey: string;
    token: string;
    region: "US" | "EU" | "AZURE_NA" | "AZURE_EU" | "GCP_NA";
    environment: string;
    branch?: string;
}
interface GenerateTSBase extends StackConnectionConfig {
    tokenType: "delivery";
    prefix?: string;
    includeDocumentation?: boolean;
    systemFields?: boolean;
}
type GenerateTS = GenerateTSBase;
interface GraphQLBase extends StackConnectionConfig {
    namespace?: string;
}
interface GenerateTSFromContentTypes {
    contentTypes: any[];
    prefix?: string;
    includeDocumentation?: boolean;
    systemFields?: boolean;
}

declare const generateTS: ({ token, tokenType, apiKey, environment, region, branch, prefix, includeDocumentation, systemFields, }: GenerateTS) => Promise<string | undefined>;
declare const generateTSFromContentTypes: ({ contentTypes, prefix, includeDocumentation, systemFields, }: GenerateTSFromContentTypes) => Promise<string>;

export { type GraphQLBase as G, generateTSFromContentTypes as a, generateTS as g };
